const express = require('express');
const fileUpload = require('express-fileupload');
const bodyParser = require('body-parser');
const mysql = require('mysql');
const path = require('path');
const app = express();

const {getHomePage} = require('./routes/index');
const {addPlayerPage, addPlayer, deletePlayer, editPlayer, editPlayerPage} = require('./routes/player');

//Vanligvis bruker nettsider port 80, så for å komme til denne siden etter at man har startet serveren med node app.js kommandoen (staret i mappen app.js filen ligger) må man bruke localhost:5000 for å få tilgang.
const port = 5000;

//Node.js server satt opp ved hjelp av veiledning fra https://dev.to/achowba/build-a-simple-app-using-node-js-and-mysql-19me
//Er en god demonstrasjon av hvordan Node benytter ulike moduler i bakgrunnen av et nettsted. Med denne guiden har man ingen typisk index.html. En person som besøker nettstedet finner en side bestående av filene fra routes og views/partials mappen. Dette er en kombinasjon av routes og path modulene.



// create connection to database
// the mysql.createConnection function takes in a configuration object which contains host, user, password and the database name.
//Mysql serveren er hostet via phpmyadmin og brukeren er opprettet for oss av NTNU.
const db = mysql.createConnection ({
    host: "mysql-ait.stud.idi.ntnu.no",
    user: "g_ano1",
    password: "EdvuK25x",
    database : 'g_ano1'
});

// connect to database
db.connect((err) => {
    if (err) {
        throw err;
    }
    console.log('Connected to database');
});
global.db = db;

//Middleware er en del av Node express-rammeverket som fungerer som funksjoner med en gitt input og repsons.

// configure middleware
app.set('port', process.env.port || port); // set express to use this port
app.set('views', __dirname + '/views'); // set express to look in this folder to render our view
app.set('view engine', 'ejs'); // configure template engine
app.use(bodyParser.urlencoded({ extended: false }));
app.use(bodyParser.json()); // parse form data client
app.use(express.static(path.join(__dirname, 'public'))); // configure express to use public folder
app.use(fileUpload()); // configure fileupload

// routes for the app
app.get('/', getHomePage);
app.get('/add', addPlayerPage);
app.get('/edit/:id', editPlayerPage);
app.get('/delete/:id', deletePlayer);
app.post('/add', addPlayer);
app.post('/edit/:id', editPlayer);


// set the app to listen on the port
app.listen(port, () => {
    console.log(`Server running on port: ${port}`);
});
//
