require('dotenv').config({ path: 'variables.env' });

   const express = require('express');
   const webPush = require('web-push');
   const bodyParser = require('body-parser');
   const path = require('path');

   const app = express();

   app.use(bodyParser.json());

  //Som express-mysql guiden er serveren satt opp med express-rammeverket og filene bruker ser når de besøker nettstedet ligger her i /client mappen. Koden under sørger for at man får tilgang til den riktig filen når.
   app.use(express.static(path.join(__dirname, 'client')));

   // Utgangspunkt i https://pusher.com/tutorials/push-notifications-node-service-workers som skal være en node server som bruker service worker for å sende push notifications. Denne Node serveren ble satt opp for å teste hvordan det er å benytte service workers med Node. Det viktigste å lære her var hvor SW.js filen skal plasseres. Riktig plassering må ligge i samme mappe som index.html filen.

   //For å få lov å benytte push varsler er det opprettet en form for frivillig identifikasjon ved bruk av Vapidkey'ene under (for serveren). Dette er en del av modulen som gjør at push varslet vises.
   const publicVapidKey = process.env.PUBLIC_VAPID_KEY;
   const privateVapidKey = process.env.PRIVATE_VAPID_KEY;

   webPush.setVapidDetails('mailto:test@example.com', publicVapidKey, privateVapidKey);

   app.post('/subscribe', (req, res) => {
     const subscription = req.body

     res.status(201).json({});

     const payload = JSON.stringify({
       title: 'Push notifications with Service Workers',
     });

     webPush.sendNotification(subscription, payload)
       .catch(error => console.error(error));
   });

   app.set('port', process.env.PORT || 5000);
   const server = app.listen(app.get('port'), () => {
     console.log(`Express running → PORT ${server.address().port}`);
   });
