var CACHE = 'offline-cache';

self.addEventListener('install', function(evt){
  console.log('Installerer service worker');

  evt.waitUntil(precache());
});

self.addEventListener('fetch', function(evt) {
  console.log('Oppdaterer cachen med data fra serveren?');

  evt.respondWith(fromCache(evt.request));

  evt.waitUntil(update(evt.request));
});

function precache() {
  return caches.open(CACHE).then(function (cache) {
    return cache.addAll([
      '/index.html',
      '/main.js',
      '/style.css'
    ]);
  });
}

function fromCache(request) {
  return caches.open(CACHE).then(function (cache) {
    return cache.match(request).then(function (matching) {
      return matching || Promise.reject('no match');
    });
  });
}

function update(request) {
  return caches.open(CACHE).then(function (cache) {
    return fetch(request).then(function (response) {
      return cache.put(request, response);
    });
  });
}

self.addEventListener('push', event => {
      const data = event.data.json();

      self.registration.showNotification(data.title, {
        body: 'Yay it works!',
      });
    });
