(function() {
  //lokal database
  var db = new Dexie("todos-dexie");
  var input = document.querySelector('input');
  var ul = document.querySelector('ul');

  //for funksjonene legge til og slette
  document.body.addEventListener('submit', onSubmit);
  document.body.addEventListener('click', onClick);

  db.version(1).stores({ todo: '_id' })
  db.open()
    .then(refreshView);

//for å slette
  function onClick(e) {
    e.preventDefault();
    if (e.target.hasAttribute('id')) {
      db.todo.where('_id').equals(e.target.getAttribute('id')).delete()
        .then(refreshView);
    }
  }

// ¨å legge til
  function onSubmit(e) {
    e.preventDefault();
    db.todo.put({ text: input.value, _id: String(Date.now()) })
      .then(function() {
        input.value = '';
      })
      .then(refreshView);
  }

// oppdatering
  function refreshView() {
    return db.todo.toArray()
      .then(renderAllTodos);
  }
//Opprette todos
  function renderAllTodos(todos) {
    var html = '';
    todos.forEach(function(todo) {
      html += todoToHtml(todo);
    });
    ul.innerHTML = html;
  }
//oversikt over elementer
  function todoToHtml(todo) {
    return '<li><button id="'+todo._id+'">delete</button>'+todo.text+'</li>';
  }
}());
