var pidbDemo = (function() {
  'use strict';

  if (!('indexedDB' in window)) {
    console.log('This browser doesn\'t support IndexedDB');
    return;
  }
  console.log('Oppretter databasen');
  var kommentarDB = idb.open('kommentarDB', 1, function(upgradeDb) {
    console.log('Oppretter ObjectStore');
    upgradeDb.createObjectStore('KommentarOS', {keyPath: 'fornavn'});
    console.log('Oppretter Indexer');
    var store = upgradeDb.transaction.objectStore('KommentarOS');
    store.createIndex('fornavn', 'fornavn', {
      unique: true});
  });

  //Legg info fra textfeltet i IDB-databasen
  //Console.log brukt til testing for å spore hvor langt i koden scriptet har kommet
    function nyHendelse() {
      console.log('Oppdaterer kommentaren');
      kommentarDB.then(function(db) {
        //console.log('Oppretter variabler');
        var fnavn = document.getElementById("fornavn").value;
        var kom = document.getElementById("kommentar").value;
        var tx = db.transaction('KommentarOS', 'readwrite');
        var store = tx.objectStore('KommentarOS');
        var items = [
          {
            fornavn: fnavn,
            hendelse: kom
          }
        ];
        return Promise.all(items.map(function(item) {
          console.log('Legger til: ', item);
          return store.add(item);
        })).catch(function(e) {
          tx.abort();
          console.log(e);
        }).then(function() {
          console.log('Alt ble lagt inn');
        });
      });
    }

//funksjon for å oppdatere verdien til kommentaren, denne koden er lik funksjonen over med untak av return store.add(item); som er endret til return store.put(item); Det bør være mulig å slå sammen disse funksjonene og ha en if kode som skjekker om fornavnen eksisterer i databasen fra før og velger store.put for å oppdatere eller store.add om det ikke eksisterer.
    function oppdaterKom(){
      kommentarDB.then(function(db) {
      var fnavn = document.getElementById("fornavn").value;
      var kom = document.getElementById("kommentar").value;
      var tx = db.transaction('KommentarOS', 'readwrite');
      var store = tx.objectStore('KommentarOS');
      var items = [
        {
        fornavn: fnavn,
        hendelse: kom
        }
      ];
      return Promise.all(items.map(function(item) {
        console.log('Legger til: ', item);
        return store.put(item);
      })).catch(function(e) {
        tx.abort();
        console.log(e);
      }).then(function() {
        console.log('Verdien ble oppdatert');
      });
      });
    }

  //Funksjon for å legge en hardkodet hendelse i databasen.
  function leggNoeIDatabasen() {
    dbHendelse.then(function(db) {
      console.log('Prøver å legge noe i databasen');
      var tx = db.transaction('hendelseOS', 'readwrite');
      var store = tx.objectStore('hendelseOS');
      var items = [
        {
          fornavn: 'Severin',
          etternavn: 'Suveren',
          hendelse: 'Uflaks!',
          timestamp: new Date().getTime()
        }
      ];
      return Promise.all(items.map(function(item) {
        console.log('Legger til: ', item);
        return store.add(item);
      })).catch(function(e) {
        tx.abort();
        console.log(e);
      }).then(function() {
        console.log('Alt ble lagt inn');
      });
    });
  }

  function visAlleHendelser() {
    console.log('Viser alle hendelser');
    var tekst = '';
    dbHendelse.then(function(db) {
      var tx = db.transaction('hendelseOS', 'readonly');
      var store = tx.objectStore('hendelseOS');
      return store.openCursor();
    }).then(function showRange(cursor) {
      if (!cursor) {
        return;
      }
      console.log('Peker er ved: ', cursor.value.timestamp);
      tekst += '<h3> Innmeldt Hendelse </h3>';
      tekst += '<p>Fornavn: ' + cursor.value.fornavn + '<br/>';
      tekst += 'Etternavn: ' + cursor.value.etternavn + '<br/>';
      tekst += 'Hendelse: ' + cursor.value.hendelse + '<br/>';
      tekst += '</p>';
      return cursor.continue().then(showRange);
    }).then(function() {
      if (tekst === '') {
        '<p>Ingen hendelser</p>';
      }
      document.getElementById('Hendelser').innerHTML = tekst;
    });

  }

  function test() {
    console.log("Testen virker!");
    console.log('Oppretter variabler');
    var fnavn = document.getElementById("fornavn").value;
    console.log(fnavn);
    var enavn = document.getElementById("etternavn").value;
    console.log(enavn);
    var hend = document.getElementById("kommentar").value;
    console.log(hend);
  }
//som for IndexedDB med Promises, fordi alt her ligger under en funksjon må vi bruker return for å få til å bruke funksjonene fra hovedsiden.
  return {test: (test), nyHendelse: (nyHendelse), visAlleHendelser: (visAlleHendelser), leggNoeIDatabasen: (leggNoeIDatabasen),
  oppdaterKom: (oppdaterKom)};

})();
