
'use strict';
var version= 'v2::';
var CACHE_NAME = 'cache';


//Filer som er kreves for å gjøre den til den offline app.
 var urls = [
'index.html',
'./' // alias for index.html 
];


self.addEventListener('install', function(event) {

//Utfører: last inn hver fil i cache

 event.waitUntil(
    caches.open(CACHE_NAME)
      .then(function(cache) {

//Legg til alle offline tilhørende filer til cache,

console.log('[install] Caches opened, adding all core components' +
          'to cache');
        return cache.addAll(urls);
      })
      .then(function() {
        console.log('[install] All required resources have been cached, ' +
          'we\'re good!');
        return self.skipWaiting();
      })
  );
});

//fetch
self.addEventListener('fetch', function(event) {
  event.respondWith(
    caches.match(event.request)
      .then(function(response) {

//Cache hit - returnere førespørselen fra den cached versjonen. 


        if (response) {
          console.log(
            '[fetch] Returning from ServiceWorker cache: ',
            event.request.url
          );
          return response;
        }

//Ikke i cache- returner resultatet fra live server fetch er en viktig "fallback"

         console.log('[fetch] Returning from server: ', event.request.url);
        return fetch(event.request);
      }
    )
  );
});

self.addEventListener('activate', function(event) {
  console.log('[activate] Activating ServiceWorker!');


//Calling claim() for å tvinge "controllerchange" hendelse på navigator. serviveWorker 
  console.log('[activate] Claiming this ServiceWorker!');
  event.waitUntil(self.clients.claim());
});