(function() {

  'use strict';

  var ENTER_KEY = 13;
  var newTodoDom = document.getElementById('new-todo');
  var syncDom = document.getElementById('sync-wrapper');

  // Begynte å gjøre endring herfra
  //lokal database som viser under indexeddb i devtools. 
  var localDB = new PouchDB('todos');
// skybasert ekstern database 
var remoteDB = new PouchDB('https://85a49bf5-e8c8-47d0-9c69-cc83c43b2a74-bluemix:33c02e667d8c25acf006562587301b66e16779d3e8e205fa7cded6f6ff34123f@85a49bf5-e8c8-47d0-9c69-cc83c43b2a74-bluemix.cloudantnosqldb.appdomain.cloud/todos');


//gir info om databasen. 
  localDB.info(function(err, info) {
    localDB.changes({
      since: info.update_seq,
      live: true,
    }).on('change', showTodos);
  });


//tilkobling status
function isOnline() {
var connectionStatus = document.getElementById('connectionStatus');
//Hvis offline:
if (navigator.onLine) {
connectionStatus.innerHTML = 'Du er online!';
} else {
 // hvis offline:  
connectionStatus.innerHTML = 'Du er offline. Alle forespøreseler vil lagt i kø og synkroniert når du er online igjen.';
}
}
//online
 window.addEventListener('online', isOnline);
 //offline
window.addEventListener('offline', isOnline);
 isOnline();


// Wi har laget et ny todo dokument og lagt det i databasene

  function addTodo(text) {
    var todo = {
      _id: new Date().toISOString(),
      title: text,
      completed: false
    };
    localDB.put(todo).then(function (result) {
      console.log("Alt er topp");
      console.log(result);
    }).catch(function (err) {
      console.log('Alt er langt fra topp :(');
      console.log(err);
    });
  }


// Viser den nåværende liste med varer med å lese de fra databasen. 
  function showTodos() {
    localDB.allDocs({include_docs: true, descending: true}, function(err, doc) {
    redrawTodosUI(doc.rows);
    }).catch(function (err) {
      console.log(err);
  });
}
//For checkbox
  function checkboxChanged(todo, event) {
  todo.completed = event.target.checked;
    console.log(todo);
  localDB.put(todo);
}

  // Ved sleeting av en vare, skjer også i databasen. 
  function deleteButtonPressed(todo) {
     localDB.remove(todo);
  }

  //Ved uklare elementer under redigering, bør vi lage den nytt 
  //navn eller slette vare hvis ikke har navn. 

  function todoBlurred(todo, event) {
    var trimmedText = event.target.value.trim();
  if (!trimmedText) {
    localDB.remove(todo);
  } else {
    todo.title = trimmedText;
    localDB.put(todo);
  }
  }


// Starte en synkronisering med en remote server
//For å se grunnlaget for endringer fra veileder se: https://github.com/pouchdb/pouchdb/issues/4385
//byt
  function sync() {
    syncDom.setAttribute('data-sync-state', 'syncing');
var opts = {live: true, retry: true};
    localDB.sync(remoteDB, opts, syncError);
    localDB.replicate.from(remoteDB, opts, syncError);

  }

  
//Det er skjedde noe feil med synkronisering, 
  function syncError() {
    syncDom.setAttribute('data-sync-state', 'error');
  }

  // Ved redigering av en vare, vise en innskrivings felt som de kan endre det. 
  function todoDblClicked(todo) {
    var div = document.getElementById('li_' + todo._id);
    var inputEditTodo = document.getElementById('input_' + todo._id);
    div.className = 'editing';
    inputEditTodo.focus();
  }


  // Hvis vi trykker enter under redigering, blir det uklart for å utløse lagre
  //(eller slett)

  function todoKeyPressed(todo, event) {
    if (event.keyCode === ENTER_KEY) {
      var inputEditTodo = document.getElementById('input_' + todo._id);
      inputEditTodo.blur();
    }
  }

  //Gitt av et elementet skal være en vare, vil dette skape en handleliste
  // for å vise det fram, 
  function createTodoListItem(todo) {
    var checkbox = document.createElement('input');
    checkbox.className = 'toggle';
    checkbox.type = 'checkbox';
    checkbox.addEventListener('change', checkboxChanged.bind(this, todo));

    var label = document.createElement('label');
    label.appendChild( document.createTextNode(todo.title));
    label.addEventListener('dblclick', todoDblClicked.bind(this, todo));

    var deleteLink = document.createElement('button');
    deleteLink.className = 'destroy';
    deleteLink.addEventListener( 'click', deleteButtonPressed.bind(this, todo));

    var divDisplay = document.createElement('div');
    divDisplay.className = 'view';
    divDisplay.appendChild(checkbox);
    divDisplay.appendChild(label);
    divDisplay.appendChild(deleteLink);

    var inputEditTodo = document.createElement('input');
    inputEditTodo.id = 'input_' + todo._id;
    inputEditTodo.className = 'edit';
    inputEditTodo.value = todo.title;
    inputEditTodo.addEventListener('keypress', todoKeyPressed.bind(this, todo));
    inputEditTodo.addEventListener('blur', todoBlurred.bind(this, todo));

    var li = document.createElement('li');
    li.id = 'li_' + todo._id;
    li.appendChild(divDisplay);
    li.appendChild(inputEditTodo);

   // for handlet elementer/ferdige. 
    if (todo.completed) {
      li.className += 'complete';
      checkbox.checked = true;
    }

    return li;
  }


  function redrawTodosUI(todos) {
    var ul = document.getElementById('todo-list');
    ul.innerHTML = '';
    todos.forEach(function(todo) {
      ul.appendChild(createTodoListItem(todo.doc));
    });
  }

  function newTodoKeyPressHandler( event ) {
    if (event.keyCode === ENTER_KEY) {
      addTodo(newTodoDom.value);
      newTodoDom.value = '';
    }
  }

  function addEventListeners() {
    newTodoDom.addEventListener('keypress', newTodoKeyPressHandler, false);
  }

  addEventListeners();
  showTodos();

  if (remoteDB) {
    sync();
  }

                
  })();