window.onload = function() {

  // Starter funksjonen for å oppdatere gjøremålslisten.
  todoDB.open(refreshTodos);

  // Henter referansene fra HTML-formene.
  var newTodoForm = document.getElementById('new-todo-form');
  var newTodoInput = document.getElementById('new-todo');

// Når et nytt gjøremål blir lagt inn (new-todo-form blir sendt inn).
newTodoForm.onsubmit = function() {
  // Hent tekstverdien.
  var text = newTodoInput.value;

  // Sjekk for at det ikke blir sendt inn tomrom eller ingenting.
  if (text.replace(/ /g,'') != '') {
    // Legg inn gjøremålet i IDB.
    todoDB.createTodo(text, function(todo) {
      refreshTodos();
    });
  }

  // Tilbakestill input feltet.
  newTodoInput.value = '';

  // Ikke send feltet (Det vil si ikke last inn en ny side som ofte blir gjort når man sender inn f.eks. php skjema.)
  return false;
  };
}

// Oppdater listen av gjøremål.
function refreshTodos() {
  todoDB.fetchTodos(function(todos) {
    var todoList = document.getElementById('todo-items');
    todoList.innerHTML = '';

    for(var i = 0; i < todos.length; i++) {
      // Les listen av gjøremål, den nyeste først
      var todo = todos[(todos.length - 1 - i)];

      var li = document.createElement('li');
      li.id = 'todo-' + todo.timestamp;
      var checkbox = document.createElement('input');
      checkbox.type = "checkbox";
      checkbox.className = "todo-checkbox";
      checkbox.setAttribute("data-id", todo.timestamp);

      li.appendChild(checkbox);

      var span = document.createElement('span');
      span.innerHTML = todo.text;

      li.appendChild(span);

      todoList.appendChild(li);

      // Event listener for å se om checkboxen blir haket av.
      checkbox.addEventListener('click', function(e) {
        var id = parseInt(e.target.getAttribute('data-id'));

        todoDB.deleteTodo(id, refreshTodos);
      });
    }

  });
}
